unit U_Cast_A_Word2;
(*
Email from : Sergio Furrer, srgfrr818@gmail.com on 12/1/2017

Dear Mr Gary,

I'd like to send you my program for this problem.

It consist in 5 steps

1) for each letter of alphabet find the "not allowed of same die" letters
2) find the allowed letters reversing previous solution
3) choose a word of the given (each word gives a permutation of solution)
4) make all combination
5) clean combination with the aid of step 1 and find solution

my best regards
*)


interface

uses
  windows, messages, sysutils, controls, forms,dialogs,stdctrls,
  uComboV2, mathslib,dffutils,
  Classes, ComCtrls;

type
  TForm1 = class(TForm)
    StaticText1: TStaticText;
    PageControl1: TPageControl;
    TabSheet1: TTabSheet;
    TabSheet2: TTabSheet;
    Label1: TLabel;
    Label2: TLabel;
    Label3: TLabel;
    Label4: TLabel;
    Label5: TLabel;
    Label6: TLabel;
    Label7: TLabel;
    Label8: TLabel;
    Label12: TLabel;
    Label13: TLabel;
    Label14: TLabel;
    Label15: TLabel;
    Label16: TLabel;
    Label17: TLabel;
    Label10: TLabel;
    Label11: TLabel;
    Label19: TLabel;
    Label20: TLabel;
    Label9: TLabel;
    Label21: TLabel;
    WordListBox: TListBox;
    UnSharedListBox: TListBox;
    SharedListBox: TListBox;
    ListBox4: TListBox;
    ListBox5: TListBox;
    ListBox6: TListBox;
    ListBox7: TListBox;
    FindDiceBtn: TButton;
    ListBox8: TListBox;
    ComboBtn: TButton;
    PruneBtn: TButton;
    ComboBox1: TComboBox;
    Memo1: TMemo;
    Label22: TLabel;
    Label23: TLabel;
    Label24: TLabel;
    Memo2: TMemo;
    procedure FormShow(Sender: TObject);
    procedure FindDiceBtnClick(Sender: TObject);
    procedure ComboBtnClick(Sender: TObject);
    procedure ComboBox1Change(Sender: TObject);
    procedure PruneBtnClick(Sender: TObject);
    procedure FormActivate(Sender: TObject);
  private
    { Private declarations }
    Forbidden: array[0..25] of string; //per memorizzare le combinazioni vietate
    function CalcoloID(P: string): LongInt;
    procedure MakeForbiddenList;
    procedure MakeAllowedList;
    procedure GetCombinations;
    Procedure ReportTime(start:TDateTime; msg:string);
    
  public
    { Public declarations }
    startTime:TDateTime;
  end;

  TIdentita = class(TObject)
  private
    FValore: LongInt;
  public
    property Valore: LongInt read FValore write FValore;

  end;

var
  Form1: TForm1;
  Parole: array[0..15]of string =('BITE', 'BREW', 'CLAY', 'FLEW', 'HELM', 'JUMP', 'JURY', 'MUTE',
                                  'NIGH', 'POST', 'QUIZ', 'RAGE', 'TILE', 'TREK', 'TROD', 'ZERO');

implementation

{$R *.dfm}

{************ FormShow **************}
procedure TForm1.FormShow(Sender: TObject);
var I, J, K, N: Integer;
    list:TStringList;
    s:string;
begin
  List:=TStringlist.create;
  WordListBox.Items.Clear;
  for I:= 0 to 15 do
    WordListBox.Items.Add(Parole[I]);
  MakeForbiddenList;
  MakeAllowedList;
  combobox1.clear;
  List.assign(wordlistbox.Items);
  with list do
  begin
    for i:=0 to list.Count-1 do
    begin
      s:=list[i];
      n:=0;
      for j:=1 to length(s) do
      begin
        k:= ord(s[j]) - ord('A');
        inc(n,length(sharedlistbox.items[k])-2);
      end;
      list[i]:=format('%2d%s',[n,s]);
    end;
    list.sort;
    for i:=0 to list.count-1 do
    begin
      combobox1.items.add(copy(list[i],3,length(list[i])));
    end;
    list.free;
  end;
  {Rearrange combobox word list by smallest total valid letter choices. These
   word will find solution fastest}
  //ComboBox1.Items.Assign(WordListBox.Items);
  ComboBtn.Enabled:= False;
  PruneBtn.Enabled:= False;
  FindDiceBtn.Enabled:= False;
end;

{******************* GetCombinations ************}
procedure TForm1.GetCombinations;
var
  I, J : Integer;
  sockcolors, s, u: string;
  t: char;
  ID: TIdentita;
begin
  screen.cursor:=crHourGLASS;
  StartTime:=Now;
  //make all combination for chosen word
  for I:= 1 to 4 do
  begin
    t:= ComboBox1.Text[I];
    J:= ord(t) - ord('A');
    u:= SharedListBox.Items[J];

    sockcolors:= Copy(u, 3{2}, Length(u));// 'CDJNPQSY';
    combos.setup(5, Length(sockcolors),combinations);
    while combos.getnext do
    with combos do
    begin  {pick all combinations of the other 5 letters which could validly
            reside on the same die as this letter}
        s:= sockcolors[selected[1]]+sockcolors[selected[2]]+sockcolors[selected[3]]+sockcolors[selected[4]]+sockcolors[selected[5]];//+sockcolors[selected[6]]+sockcolors[selected[7]]+sockcolors[selected[8]];//+sockcolors[selected[9]];
        ID:= TIdentita.Create;

        ID.Valore:= CalcoloID(t + s);

        if I= 1 then listbox4.items.AddObject(t + s, ID)
        else if I = 2 then listbox5.items.AddObject(t + s, ID)
        else if I = 3 then listbox6.items.AddObject(t + s, ID)
        else listbox7.items.AddObject(t + s, ID);

    end;
    application.processmessages;

  end; //fine ciclo tile

  reportTime(startTime, 'Generate combinations');
  Application.ProcessMessages;
  screen.cursor:=crDefault;


  Label1.Caption:= IntToStr(ListBox4.Items.Count);
  Label2.Caption:= IntToStr(ListBox5.Items.Count);
  Label3.Caption:= IntToStr(ListBox6.Items.Count);
  Label4.Caption:= IntToStr(ListBox7.Items.Count);
end;

{************** ReportTime **************}
Procedure TForm1.ReportTime(start:TDateTime; msg:string);
begin
  with memo1.lines do
  begin
    add(format('%s  %.1f seconds',[msg, (now-start)*secsperday]));
  end;
end;

{************* ComboBox1Change ********}
procedure TForm1.ComboBox1Change(Sender: TObject);
begin
  memo1.Clear;
  ListBox4.Items.Clear;
  ListBox5.Items.Clear;
  ListBox6.Items.Clear;
  ListBox7.Items.Clear;
  ListBox8.Items.Clear;
  Label1.Caption:= 'Original';
  Label2.Caption:= 'Original';
  Label3.Caption:= 'Original';
  Label4.Caption:= 'Original';
  Label5.Caption:= 'Pruned';
  Label6.Caption:= 'Pruned';
  Label7.Caption:= 'Pruned';
  Label8.Caption:= 'Pruned';
  ComboBtn.Enabled:= True;
  prunebtn.Enabled:=false;
  FindDicebtn.Enabled:=false;
end;

{*************** FindDiceBtn *************}
procedure TForm1.FindDiceBtnClick(Sender: TObject);
var
  I, J, K, L, M: Integer;
  N2,N3,N4: LongInt;
  flag: Boolean;
  s, t, u, v: integer;
  //Taz: string;
  //TazObj: Integer;
  //LBSet4,LBSet5:Set of char;
  ss:string;
  {------------ CheckSolution -----------}
  function CheckSolution(A, B, C, D: string): Boolean;
  {These four 6-character strings contain all 24 letters. This routine
   checks that all 16 given words can be rolled}
  var E, F, Tot: Integer;
      H: char;
      X: Boolean;
  begin
    X:= True;
    for E:= 0 to WordListBox.Items.Count - 1 do
    begin
      Tot:= 0;
      for F:= 1 to 4 do
      begin
        H:= WordListBox.Items[E][F];
        (*
        if Pos(H, A) > 0 then Tot:= Tot + 1
        else if Pos(H, B) > 0 then Tot:= Tot + 3
            else if Pos(H, C) > 0 then Tot:= Tot + 7
                else if Pos(H, D) > 0 then Tot:= Tot + 15;
        *)
        if Pos(H, A) > 0 then inc(Tot);
        if Pos(H, B) > 0 then inc(tot);
        if Pos(H, C) > 0 then inc(tot);
        if Pos(H, D) > 0 then inc(Tot);
      end;

      if Tot <> 4 {26} then X:= False;
    end;
    Result:= X;
  end;

begin
  //N:= 0;
  flag:= False;
  I:= 0;
  listbox8.clear;
  screen.Cursor:=crHourGlass;
  starttime:=now;
  while I < ListBox4.Items.Count do
  begin
    s:= TIdentita(ListBox4.Items.Objects[I]).Valore;
    begin
      J:= 0;
      while J < ListBox5.Items.Count do
      begin
        t:= TIdentita(ListBox5.Items.Objects[J]).Valore;
        if (s and t) = 0 then
        begin
          N2:= s or t; //sommo le lettere trovate
          K:= 0;
          while K < ListBox6.Items.Count do
          begin
            u:= TIdentita(ListBox6.Items.Objects[K]).Valore;
            if (N2 and u) = 0 then
            begin
              N3:= N2 or u;
              L:= 0;
              while L < ListBox7.Items.Count do
              begin
                v:= TIdentita(ListBox7.Items.Objects[L]).Valore;
                if (N3{(s or t or u)} and v) = 0 then
                begin
                  N4:= N3 or v;
                  //56623103=  11010111111111111111111111 {gdd}
                  //           zyxwvutsrqponmlkjihgfedcba
                  if N4 = 56623103 then
                  begin
                    {Verify solution}
                    flag:= CheckSolution(ListBox4.Items[I], ListBox5.Items[J], ListBox6.Items[K], ListBox7.Items[L]);
                    if flag then
                    with listbox8,items do
                    begin
                      Add(format('%s (Combo #%d)',[ListBox4.Items[I],I+1]));
                      Add(format('%s (Combo #%d)',[ListBox5.Items[J],J+1]));
                      Add(format('%s (Combo #%d)',[ListBox6.Items[K],K+1]));
                      Add(format('%s (Combo #%d)',[ListBox7.Items[L],L+1]));
                      Add('');
                      Add('Solution with sorted face letters');

                      for m:=0 to 3 do
                      begin {sort solution letters}
                        ss:=copy(items[m],1,6);
                        sortstrUp(ss); {from DFFUtils unit}
                        add(ss+ copy(items[m],7,length(items[m])));
                      end;
                    end;
                  end;
                end;
                if flag then Break;
                inc(L);
              end;
            end;
            if flag then Break;
            Inc(K);
          end;
        end;
        if flag then Break;
        inc(J);
      end;
    end; //exclusione
    if flag then Break;
    inc(I);
  end;
  reporttime(Starttime, 'Time to find solution');
  screen.Cursor:=crDefault;
end;


{****************** ComboBtnClick ************8}
procedure TForm1.ComboBtnClick(Sender: TObject);
begin
  ComboBox1Change(sender);
  GetCombinations;
  PruneBtn.Enabled:= True;
end;

{******** PruneBtnClick ***************}
procedure TForm1.PruneBtnClick(Sender: TObject);

  {----------------- Check ----------------}
  function Check(P: string): boolean;
  var
    H, I, J: Integer;
    {S,} C: string;
    S:Char;
    Flag: Boolean;
  begin
    Flag:= True;
    //check for forbidden combinations
    for H:= 1 to Length(P) - 1 do
    begin
      S:= P[H];
      i:=ord(S)- ord('A');
      //for I:= 0 to UnSharedListBox.Items.Count - 1 do
      //begin
        //if UnSharedListBox.Items[I][1]<> S then  showmessage('Oops') else
        //begin
          for J:= 3{2} to Length(UnSharedListBox.Items[I]) do
          begin
            C:= UnSharedListBox.Items[I][J];
            if Pos(C, P) > 0 then
            begin
              Flag:= False;
              Break;
            end;
          end;
        //end;
        //if not Flag then Break;
      //end;
      //if not Flag then Break;
    end;
    Result:= Flag;
  end;


var I: Integer;
begin
  //delete not allowed combination (NOT list)

  screen.Cursor:=crHourGlass;
  starttime:=now;
  for I:= ListBox4.Items.Count - 1 downto 0 do
  begin
    if not Check(ListBox4.Items[I]) then
    begin
      ListBox4.Items.Delete(I);
      if i and $FF =0 then
      begin
        Label5.Caption:= IntToStr(ListBox4.Items.Count);
        label5.update;
      end;
    end;
  end;
  Label5.Caption:= IntToStr(ListBox4.Items.Count);

  //application.processmessages;
  for I:= ListBox5.Items.Count - 1 downto 0 do
  begin
    if not Check(ListBox5.Items[I]) then
    begin
      ListBox5.Items.Delete(I);
      if I aND $FF=0 then
      begin
        Label6.Caption:= IntToStr(ListBox5.Items.Count);
        Label6.Update;
      end;
    end;
  end;
  Label6.Caption:= IntToStr(ListBox5.Items.Count);
  for I:= ListBox6.Items.Count - 1 downto 0 do
  begin
    if not Check(ListBox6.Items[I]) then
    begin
      ListBox6.Items.Delete(I);
      if I and $FF=0 then
      begin
        Label7.Caption:= IntToStr(ListBox6.Items.Count);
        Label7.Update;
       end;
    end;
    Label7.Caption:= IntToStr(ListBox6.Items.Count);
  end;
  for I:= ListBox7.Items.Count - 1 downto 0 do
  begin
    if not Check(ListBox7.Items[I]) then
    begin
      ListBox7.Items.Delete(I);
      if I and $FF=0 then
      begin
        Label8.Caption:= IntToStr(ListBox7.Items.Count);
        Label8.Update;
      end;
    end;
  end;
  Label8.Caption:= IntToStr(ListBox7.Items.Count);
  reportTime(starttime, 'Purge invalid combos');
  {
  Label5.Caption:= IntToStr(ListBox4.Items.Count);
  Label6.Caption:= IntToStr(ListBox5.Items.Count);
  Label7.Caption:= IntToStr(ListBox6.Items.Count);
  Label8.Caption:= IntToStr(ListBox7.Items.Count);
  }
  FindDiceBtn.Enabled:= True;
  screen.Cursor:=crDefault;
end;

{************** CalcColoId ***************}
function TForm1.CalcoloID(P: string): Integer;
{Turn a string into an integer with binary 1 in each letter position}
var
  I, J, N: Integer;
  C: Char;
begin
  N:= 0;
  for I:= 1 to Length(P) do
  begin
    C:= P[I];
    J:= ord(C) - Ord('A');
    N:= N or IntPower(2, J);
  end;
  Result:= N;
end;




{************* MakeAllowedList **************}
procedure TForm1.MakeAllowedList;
var I, J: Integer;
    S: string;
    ss:AnsiChar;
begin
  //allowed combination
  SharedListBox.Clear;

  for I:= 0 to UnSharedListBox.Items.Count - 1 do
  begin
    S:= UnSharedListBox.Items[I][1]+':' ;

    for J:= ord('A') to ord('Z') do //(65 to 90 do
    begin
      SS:= AnsiChar(J);
      //if (SS <> 'V') and (SS <> 'X') then
      if not (ss in ['V','X',':']) then
      if Pos(SS, UnSharedListBox.Items[I]) = 0 then
      begin
        S:= S + AnsiChar(J);
      end;
    end;
    SharedListBox.Items.Add(S);
  end;
end;

{************** MakeForbiddenList ************}
procedure TForm1.MakeForbiddenList;
var
  I, J, K: Integer;
  C, T: string;
begin
  //fill forbidden combination
  UnSharedListBox.Items.Clear;
  for I:= 0 to 25 do  // A..Z
  begin
    C:= AnsiChar(ord('A') + I);
    Forbidden[I]:= '';
    for J:= 0 to 15 do
    begin
      if Pos(C, Parole[J]) > 0 then
      begin
        for K:= 0 to Length(Parole[J]) - 1 do
        begin
          T:= Parole[J][K + 1];
          if T <> C then
          begin
            if Pos(T, Forbidden[I]) = 0 then
              Forbidden[I]:= Forbidden[I] + T;
          end;
        end;
      end;
    end;
  end;
  for I:= 0 to 25 do
  begin
    C:= AnsiChar(ord('A') + I) +':'+ Forbidden[I];
    UnSharedListBox.Items.Add(C);
  end;
end;

procedure TForm1.FormActivate(Sender: TObject);
begin
  reformatmemo(memo2);
end;

end.
